
! This module reads in an intermolecular PES parameter file generated by autoPES,
!    and evaluates the fit energy. The input_long file should be read in using the
!    dimer module before the PES is read in. This module also contains routines for
!    indexing the free parameters of the short-range fit and evaluating their derivatives.

module force_field_gen
  use double
  use const
  use utility
  use dimer
  implicit none
  
  ! Parameter type indices
  integer, private, parameter :: T_alpha = 1, T_beta = 2, T_an = 3
  
  ! Parameter type2 indices (global, site-specific, or site-pair-specific)
  integer, private, parameter :: T2_glb = 1, T2_s = 2, T2_sp = 3
  
  type parm
     integer :: indx, indx2
     integer :: type, type2
  end type parm
  
  integer, private, parameter :: CR_ALPHA = CR_ARITH, CR_BETA = CR_ARITH, CR_LIN = CR_ARITH
  integer, parameter :: moltypeAB(2) = [1,2]
  
  real(8), allocatable :: stcharge(:), pz(:)
  real(8), allocatable :: alpha(:), beta(:), delta1(:), deltap(:), deltan(:,:)
  real(8), allocatable :: chargeProd(:), a(:,:), C(:,:), A12(:)
  type(parm), private, allocatable :: parms(:)
  integer, private :: comModeExp, comModeLin
  integer :: oPoly, nDisp, cStart
  integer, private :: nparm
  logical :: incPol, incElsDmp, incPolDmp, incCore
  
contains


! Evaluate energy components
function energy_ff_gen(moltypeIn)
  use dimer
  use polarization
  implicit none
  
  real(8) :: energy_ff_gen(n_FF_comp)
  integer, intent(in), optional :: moltypeIn(2)
  integer :: mt(2)
  real(8) :: enerij(n_FF_comp), rAB
  integer :: i, j, k
  
  if (present(moltypeIn)) then
     mt = moltypeIn
  else
     mt = moltypeAB
  endif
  
  ! Evaluate 2-body potential
  energy_ff_gen(:) = 0.0d0
  do i = 1,nsite(mt(1))
     do j = 1,nsite(mt(2))
        rAB = sqrt( &
             (sit(1,i,1) - sit(2,j,1))**2 + &
             (sit(1,i,2) - sit(2,j,2))**2 + &
             (sit(1,i,3) - sit(2,j,3))**2)
        enerij = energy_ff_gen_ij(typeMap(stype(mt(1),i),stype(mt(2),j)), rAB)
        do k = 1,n_FF_comp
           energy_ff_gen(k) = energy_ff_gen(k) + enerij(k)
        enddo
     enddo
  enddo
  
  ! Evaluate many-body potential
  if (incPol) energy_ff_gen(F_pol) = polEnergy(sit, 2, mt, MAX_POL_ITER, stcharge, pz, delta1, deltap)
end function energy_ff_gen


! Evaluate contribution of given site site type at distance r of two-body potential
function energy_ff_gen_ij(sptype, r)
  use dimer
  use utility
  implicit none
  
  real(8) :: energy_ff_gen_ij(n_FF_comp)
  integer, intent(in) :: sptype
  real(8), intent(in) :: r
  real(8) :: Eexp, Evdw, Epol, Eels
  real(8) :: sum, rPow, rInv, rInv2
  integer :: k
  
  Eexp = 0.0d0
  Evdw = 0.0d0
  Eels = 0.0d0
  
  rInv = 1.0d0/r
  rInv2 = rInv*rInv
  
  Eels = Eels + TT(1, delta1(sptype), r)*chargeProd(sptype)*rInv
  
  Eexp = Eexp + A12(sptype)*rInv2**6
  if (beta(sptype) > 0.0d0) then
     sum = 1.0d0
     rPow = 1.0d0
     
     do k = 1,oPoly
        rPow = rPow*r
        sum = sum + rPow*a(k,sptype)
     enddo
     Eexp = Eexp + sum*exp(alpha(sptype) - beta(sptype)*r)
  endif
  
  rPow = rInv2**((cStart - 2)/2)
  do k = 1,nDisp
     rPow = rPow*rInv2
     Evdw = Evdw - TT(cStart + 2*(k-1), deltan(sptype,k), r)*C(sptype,k)*rPow
  enddo
  
  energy_ff_gen_ij(F_exp) = Eexp
  energy_ff_gen_ij(F_els) = Eels
  energy_ff_gen_ij(F_vdw) = Evdw
  energy_ff_gen_ij(F_pol) = 0.0d0
  return
end function energy_ff_gen_ij


! Read in PES information from given file
! Ignores redundant info already read from dimer file
subroutine read_fit_gen(filename)
  use dimer 
  implicit none
  
  character(*), intent(in) :: filename
  
  integer :: i, j
  integer :: ncol, index, index2, nParmPerSpt
  integer :: stype1, stype2, sptype
  integer :: nsptype_in, nOACoor
  real(8) :: val, rBuf(100)
  real(8) :: OACoor(2,MAX_IDOF)
  character(1000) :: line
  
  if (allocated(stcharge)) then
     deallocate(stcharge,pz)
     deallocate(alpha,beta,delta1,deltap,deltan,C,a,A12,chargeProd)
  endif
  
  open(100,file=filename,status='old')
  
  read(100,*) oPoly, nDisp, cStart
  read(100,'(A)') line
  
  do i = 1,2
     read(100,'(A)') line
  enddo
  
  OACoor(:,:) = 0.0d0
  read(100,*) nOACoor
  do i = 1,nOACoor
     read(100,*) index, index2, val
     OACoor(index,index2) = val
  enddo
  call setOACoor(OACoor)
  
  allocate( stcharge(nstype), pz(nstype) )
  
  incElsDmp = .false.
  incPol = .false.
  incPolDmp = .false.
  incCore = .false.
  do i = 1,nstype
     read(100,*) rBuf(1),rBuf(2)
     stcharge(i) = rBuf(1)
     pz(i) = rBuf(2)
     if (pz(i) > 1.0d-20) incPol = .true.
  enddo
  
  read(100,*) nsptype_in
  
  allocate( alpha(nsptype), beta(nsptype), delta1(nsptype), deltap(nsptype) )
  allocate( deltan(nsptype,nDisp), C(nsptype,nDisp) )
  allocate( a(oPoly,nsptype) )
  allocate( A12(nsptype) )
  allocate( chargeProd(nsptype) )
  
  nParmPerSpt = 1 + 1 + oPoly + nDisp + 1 + 1 + nDisp
  if (incPol) nParmPerSpt = nParmPerSpt + 1
  
  do i = 1,nsptype_in
     read(100,*) stype1, stype2, rBuf(1:nParmPerSpt)
     sptype = typeMap(stype1,stype2)
     
     chargeProd(sptype) = h2kcal*stcharge(stype1)*stcharge(stype2)
     
     index = 1
     beta(sptype) = rBuf(index)*bohr2A
     index = index + 1
     alpha(sptype) = rBuf(index)
     index = index + 1
     do j = 1,oPoly
        a(j,sptype) = rBuf(index)*bohr2A**j
        index = index + 1
     end do
     do j = 1,nDisp
        C(sptype,j) = rBuf(index)*A2bohr**(cstart + 2*(j-1))
        index = index + 1
     enddo
     A12(sptype) = rBuf(index)*A2bohr**12
     if (abs(A12(sptype)) > 1.0d-10) incCore = .true.
     index = index + 1
     delta1(sptype) = rBuf(index)*bohr2A
     if (delta1(sptype) < 1.0d3) incElsDmp = .true.
     index = index + 1
     do j = 1,nDisp
        deltan(sptype,j) = rBuf(index)*bohr2A
        index = index + 1
     enddo
     if (incPol) then
        deltap(sptype) = rBuf(index)*bohr2A
        if (deltap(sptype) < 1.0d3) incPolDmp = .true.
        index = index + 1
     endif
  enddo
  !delta1(:) = 1.0d10
  !deltan(:,:) = 1.0d10
  !deltap(:) = 1.0d10
  
  close(100)
end subroutine read_fit_gen


! Initialize data related to free parameters
! Returns number of free parameters
integer function initFreeParm(comModeExpIn, comModeLinIn)
  integer, intent(in) :: comModeExpIn, comModeLinIn
  integer :: st1, st2
  integer :: i, j
  
  comModeExp = comModeExpIn
  comModeLin = comModeLinIn
  
  allocate( parms(nsptype*(10 + 2*ndisp + opoly)) )
  
  nparm = 0
  do i = 1,nstype
     if (incInter(i,F_exp)) then
        if (comModeExp == 1) then
           nparm = nparm + 1
           parms(nparm) = parm(i,0,T_alpha,T2_s)
           nparm = nparm + 1
           parms(nparm) = parm(i,0,T_beta,T2_s)
        endif
        if (comModeLin == 1) then
           do j = 1,oPoly
              nparm = nparm + 1
              parms(nparm) = parm(i,j,T_an,T2_s)
           enddo
        endif
     endif
  enddo
  do i = 1,nsptype
     st1 = typeMapInv(i,1)
     st2 = typeMapInv(i,2)
     if (incInter(st1,F_exp) .and. incInter(st2,F_exp)) then
        if ((stcount(1,st1) > 0 .and. stcount(2,st2) > 0) .or. &
             (stcount(1,st2) > 0 .and. stcount(2,st1) > 0)) then
           if (comModeExp == 0) then
              nparm = nparm + 1
              parms(nparm) = parm(i,0,T_alpha,T2_sp)
              nparm = nparm + 1
              parms(nparm) = parm(i,0,T_beta,T2_sp)
           endif
           if (comModeLin == 0) then
              do j = 1,oPoly
                 nparm = nparm + 1
                 parms(nparm) = parm(i,j,T_an,T2_sp)
              enddo
           endif
        endif
     endif
  enddo
  
  initFreeParm = nparm
end function initFreeParm


! Returns the current value of the requested free parameter
real(8) function getFreeParm(iparm)
  integer, intent(in) :: iparm
  integer :: spt
  integer :: i, j
  
  if (parms(iparm)%type2 == T2_sp) then
     spt = parms(iparm)%indx
  elseif (parms(iparm)%type2 == T2_s) then
     spt = typeMap(parms(iparm)%indx,parms(iparm)%indx)
  endif
  
  select case(parms(iparm)%type)
  case(T_alpha)
     getFreeParm = alpha(spt)
  case(T_beta)
     getFreeParm = beta(spt)
  case(T_an)
     getFreeParm = a(parms(iparm)%indx2,spt)
  end select
end function getFreeParm


! Sets the given free parameter to the given value
subroutine setFreeParm(iparm, val)
  integer, intent(in) :: iparm
  real(8), intent(in) :: val
  integer :: type
  integer :: i, j, k
  
  type = parms(iparm)%type
  select case(type)
  case(T_alpha)
     call setParmArray(val, alpha, parms(iparm)%indx, parms(iparm)%type2, CR_ALPHA)
  case(T_beta)
     call setParmArray(val, beta, parms(iparm)%indx, parms(iparm)%type2, CR_BETA)
  case(T_an)
     call setParmArray(val, a(parms(iparm)%indx2,:), parms(iparm)%indx, parms(iparm)%type2, CR_LIN)
  end select
end subroutine setFreeParm


! Modifies a map from site pair types to parameter values by setting a free parameter
! val : parameter value to be set
! array : array of existing values
! indx : the index value of the parameter. What it means depends on the type2
!   of the parameter
! type2 : the type2 value of the parameter
! comrule : combination rule to use. Only used if type2 is site-specific
subroutine setParmArray(val, array, indx, type2, comrule)
  real(8), intent(in) :: val
  real(8), intent(inout) :: array(nsptype)
  integer, intent(in) :: indx, type2, comrule
  integer :: i
  
  if (type2 == T2_glb) then
     array(1:nsptype) = val
  elseif (type2 == T2_s) then
     array(typemap(indx,indx)) = val
     do i = 1,nstype
        array(typeMap(i,indx)) = combine(val,array(typeMap(i,i)),comrule)
     enddo
  elseif (type2 == T2_sp) then
     array(indx) = val
  endif
end subroutine setParmArray


! Calculate numerical derivative of energy with respect to given free parameter
function getdudp(iparm)
  real(8) :: getdudp
  integer :: iparm
  real(8) :: val, eplus, eminus, eps
  
  val = getFreeParm(iparm)
  eps = 1.0d-5*(1.0d0 + abs(val))
  
  call setFreeParm(iparm, val + eps/2)
  eplus = sum(energy_ff_gen())
  call setFreeParm(iparm, val - eps/2)
  eminus = sum(energy_ff_gen())
  call setFreeParm(iparm, val)
  
  getdudp = (eplus - eminus)/eps
end function getdudp


end module force_field_gen

